<?php
/**
 * BookiFlex Payment Extension
 *
 * @package    BookiFlex
 * @subpackage Payment
 * @author     BookiFlex
 * @copyright  Copyright (c) 2025 BookiFlex
 * @license    GPL-2.0-or-later
 *
 * @link       https://bookiflex.com
 */

declare(strict_types=1);

 namespace BookiFlex\Extensions\Payment\ORM\Typecast;

use BookiFlex\Core\Contract\Payment\PaymentStatus;
use Cycle\ORM\Parser\CastableInterface;
use Cycle\ORM\Parser\UncastableInterface;

defined( 'ABSPATH' ) || exit;

class PaymentStatusTypecast implements CastableInterface, UncastableInterface
{
    public function setRules(array $rules): array
    {
        // Rules can be set here if necessary
        return $rules;
    }

    public function cast(array $data): array
    {
        if (isset($data['status']) && is_string($data['status'])) {
            $data['status'] = new PaymentStatus($data['status']);
        }

        return $data;
    }

    public function uncast(array $data): array
    {
        if (isset($data['status']) && $data['status'] instanceof PaymentStatus) {
            $data['status'] = $data['status']->getValue();
        }

        return $data;
    }
}
